library IEEE;
use IEEE.std_logic_1164.all;


-- Deskribapen hau ASM algoritmoari dagokio.

entity AU_IN_KU is 
port (
clk,reset: in std_logic;
ENABLEIN, ADCLRCSINK, BCLKSINK, AZKEN: in std_logic;
LD_SAM, LD_KONT, DESP, DEKONT, READYIN: out std_logic
);
end AU_IN_KU;

architecture arki of AU_IN_KU is 

type EGOERA is (e0,e1,e2,e3,e4,e5); --e5,
signal UE,HE: EGOERA;

begin -- arkitekturaren definizioa

process (UE, ENABLEIN, ADCLRCSINK, BCLKSINK, AZKEN) 
begin
case UE is
  when e0 => if ENABLEIN='1' then HE<=e1;
                else HE<= e0;
             end if;
			 
  when e1 => if ADCLRCSINK='0' then HE<= e2;
                else HE<= e1;
             end if;
				
  when e2 => if ADCLRCSINK='0' then HE<= e2;
					 elsif BCLKSINK='1' then HE<= e2;
					 else HE<= e3;
			 end if;
	
  when e3 => if BCLKSINK='1' then HE<= e4;
				else HE<= e3;  
			 end if;
		
  when e4 => if BCLKSINK='1' then HE<= e4;
				elsif AZKEN='1' then HE<= e5; 
				else HE<= e3; 
			 end if;
		
  when e5 =>  HE<= e0;
   
end case;
end process;

-- prozesu sinkrono batean, uneko egoera (UE) erregistratzen da erloju-ertzero.
-- reset asinkronoa
process (clk,reset)
begin
if reset='1' then UE<=e0;
             elsif (clk'event and clk='1') then UE<=HE;
end if;
end process;
-- kontrol-seinale bakoitzeko, esleipen konkurrente bat
LD_SAM <= '1' when (UE=e0 and ENABLEIN='1') else '0'; 
LD_KONT <= '1' when (UE=e0 and ENABLEIN='1') else '0'; 
DESP <= '1' when (UE=e3 and BCLKSINK='1') else '0'; 
DEKONT <= '1' when (UE=e3 and  BCLKSINK='1') else '0';
READYIN <= '1' when (UE=e5) else '0';

end arki; -- arkitekturaren bukaera

