library IEEE;
use IEEE.std_logic_1164.all;
use ieee.numeric_std.all;

-- Kronograma eskuz betetzeko erabili dugun ariketa (bigarrena).
-- Diseinuaren helburua: bi zenbaki osoen arteko biderketa egitea
-- Zenbakiak 2rako osagarrian adierazita daude.
-- Diseinua (ASM+PU) eta kronograma betetzeko eskema egelan daude eskura.
-- Deskribapen hau ASM algoritmoari dagokio.

entity AU_IN_PU_KU is
port (
clk,reset: in std_logic;
ENABLEIN: in std_logic;
SAMPLEIN: out std_logic_vector (15 downto 0);
ADCDAT: in std_logic;
BCLK: in std_logic;
ADCLRC: in std_logic;
READYIN: out std_logic
);
end AU_IN_PU_KU;

architecture arki_out of AU_IN_PU_KU is

  --erazagupenak: osagaiak eta barne seinaleak
component AU_IN_KU
port (
clk,reset: in std_logic;
ENABLEIN, ADCLRCSINK, BCLKSINK, AZKEN: in std_logic;
LD_SAM, LD_KONT, DESP, DEKONT, READYIN: out std_logic
);
end component;

  signal LD_SAM,LD_KONT : std_logic;
  signal DESP,DEKONT: std_logic;
  signal ADCLRCSINK, BCLKSINK, AZKEN: std_logic;
  signal Q_KONT: unsigned (4 downto 0);
  signal Q_SAMPLE: std_logic_vector (15 downto 0);
 
begin -- arkitekturaren hasiera

  ku: AU_IN_KU
  port map (
    clk => clk,
    reset => reset, ENABLEIN => ENABLEIN,
    AZKEN => AZKEN, READYIN => READYIN, LD_SAM => LD_SAM, LD_KONT => LD_KONT, DESP => DESP, DEKONT => DEKONT, BCLKSINK => BCLKSINK, ADCLRCSINK => ADCLRCSINK
    );


   process(clk, Q_SAMPLE)
   begin
    if clk'event and clk='1'  then
        if LD_SAM='1'  then Q_SAMPLE<="0000000000000000";
        elsif DESP='1' then 
		for I in 1 to 15 loop
                    Q_SAMPLE(I)<=Q_SAMPLE(I-1);
                end loop;
            Q_SAMPLE(0)<=ADCDAT;
            end if;
        end if;
	SAMPLEIN<=Q_SAMPLE;
end process;



-- D biegonkorrak
process(clk)
begin
if CLK'event and CLK='1' then
BCLKSINK <= BCLK;
end if;
end process;
 

process(clk)
begin
if CLK'event and CLK='1' then
ADCLRCSINK<= ADCLRC;
end if; 
end process;
                    

    -- emaitza-erregistroaren aurreko multiplexorea
    -- DACDAT<= Q_SAMPLE(15) when AUKBIT='1' else '0';

    -- Kontagailua
    process(clk)
    begin
      if clk'event and clk='1' then
        if LD_KONT='1' then Q_KONT<="10000";
          elsif DEKONT='1' then Q_KONT<= Q_KONT-1;
        end if;
      end if;
    end process;
   AZKEN<='1' when (Q_KONT="00000") else '0';

end arki_out;
