library IEEE;
use IEEE.std_logic_1164.all;


-- Deskribapen hau ASM algoritmoari dagokio.

entity AU_OUT_KU is 
port (
clk,reset: in std_logic;
ENABLE, DACLRCSINK, BCLKSINK, AZKENA: in std_logic;
LDSAMPLE, LDBEG, DESEZK, DEKBEG, READYOUT, AUKBIT: out std_logic
);
end AU_OUT_KU;

architecture arki of AU_OUT_KU is 

type EGOERA is (e0,e1,e2,e3,e4,e5,e6,e7,e8);
signal UE,HE: EGOERA;

begin -- arkitekturaren definizioa

process (ENABLE, DACLRCSINK, BCLKSINK, AZKENA, UE) 
begin
case UE is
  when e0 => if ENABLE='1' then HE<=e1;
                    else HE<=e0;
            end if;
  when e1 => HE<= e2;
  when e2 => if DACLRCSINK='0' then HE<= e3;
                    else HE<= e2;
            end if;
  when e3 => if DACLRCSINK='1' and BCLKSINK='0' then HE<=e4;
					else HE<= e3;
			end if;
  when e4 => if BCLKSINK='1' then HE<=e5;
					else HE<=e4;  
			end if;
  when e5 => if BCLKSINK='0' then HE<=e6;
					else HE<=e5;  
			end if;
  when e6 => if AZKENA='0' then HE<=e4;
					else HE<=e7;
			end if;
  when e7 => if DACLRCSINK='1' then HE<=e8;
					else HE<=e0;
			end if;
   when e8 => if DACLRCSINK='0' and BCLKSINK='0' then HE<=e4;
					else HE<=e8; 
			end if;

end case;
end process;

-- prozesu sinkrono batean, uneko egoera (UE) erregistratzen da erloju-ertzero.
-- reset asinkronoa
process (clk,reset)
begin
if reset='1' then UE<=e0;
             elsif (clk'event and clk='1') then UE<=HE;
end if;
end process;
-- kontrol-seinale bakoitzeko, esleipen konkurrente bat
LDSAMPLE <= '1' when (UE=e0 and ENABLE='1') else '0'; 
LDBEG <= '1' when ((UE=e0 and ENABLE='1') or (UE=e8 and DACLRCSINK='0' and BCLKSINK='0')) else '0'; 
DESEZK <= '1' when (UE=e5 and BCLKSINK='0') else '0'; 
DEKBEG <= '1' when (UE=e5 and  BCLKSINK='0') else '0';
AUKBIT <= '1' when (UE=e4 or UE=e5) else '0';
READYOUT <=  '1' when (UE=e1) else '0';

end arki; -- arkitekturaren bukaera

