library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity DE1SOC_ERREPRO is
 port(
	-- CLOCK ----------------
	CLOCK_50	: in	std_logic;
--	CLOCK2_50	: in	std_logic;
--	CLOCK3_50	: in	std_logic;
--	CLOCK4_50	: in	std_logic;
	-- KEY ----------------
	KEY 		: in	std_logic_vector(3 downto 0);
--	KEY 		: in	std_logic_vector(3 downto 0);
	-- SW ----------------
	SW 		: in	std_logic_vector(0 downto 0);
--	SW 		: in	std_logic_vector(9 downto 0);
	-- LEDR ----------------
	LEDR 		: out	std_logic_vector(0 downto 0);
--	LEDR 		: out	std_logic_vector(9 downto 0);	
	-- GPIO ----------------
--	GPIO_0 		: inout	std_logic_vector(35 downto 0);
--	GPIO_1 		: inout	std_logic_vector(35 downto 0)
	-- ADC ----------------
--	ADC_CS_N	: out	std_logic;
--	ADC_DIN		: out	std_logic;
--	ADC_DOUT	: in	std_logic;
--	ADC_SCLK	: out	std_logic;
	-- CODEC Audio ----------------
	AUD_ADCDAT	: in	std_logic;
	AUD_ADCLRCK	: in	std_logic;
	AUD_BCLK	   : in	std_logic;
	AUD_DACDAT	: out	std_logic;
	AUD_DACLRCK	: in	std_logic;
	AUD_XCK		: out	std_logic;
	-- SDRAM ----------------
--	DRAM_ADDR	: out	std_logic_vector(12 downto 0);
--	DRAM_BA		: out	std_logic_vector(1 downto 0);
--	DRAM_CAS_N	: out	std_logic;
--	DRAM_CKE	: out	std_logic;
--	DRAM_CLK	: out	std_logic;
--	DRAM_CS_N	: out	std_logic;
--	DRAM_DQ		: inout	std_logic_vector(15 downto 0);
--	DRAM_LDQM	: out	std_logic;
--	DRAM_RAS_N	: out	std_logic;
--	DRAM_UDQM	: out	std_logic;
--	DRAM_WE_N	: out	std_logic;
	-- I2C for Audio and Video-In ----------------
	FPGA_I2C_SCLK	: out	std_logic;
	FPGA_I2C_SDAT	: inout	std_logic
	-- SEG7 ----------------
--	HEX0	: out	std_logic_vector(6 downto 0);
--	HEX1	: out	std_logic_vector(6 downto 0);
--	HEX2	: out	std_logic_vector(6 downto 0);
--	HEX3	: out	std_logic_vector(6 downto 0);
--	HEX4	: out	std_logic_vector(6 downto 0);
--	HEX5	: out	std_logic_vector(6 downto 0);
	-- IR ----------------
--	IRDA_RXD	: in	std_logic;
--	IRDA_TXD	: out	std_logic;
	-- PS2 ----------------
--	PS2_CLK		: in	std_logic;
--	PS2_CLK2	: in	std_logic;
--	PS2_DAT		: inout	std_logic;
--	PS2_DAT2	: inout	std_logic;
	-- Video-In ----------------
--	TD_CLK27	: in	std_logic;
--	TD_DATA		: in	std_logic_vector(7 downto 0);
--	TD_HS		: in	std_logic;
--	TD_RESET_N	: out	std_logic;
--	TD_VS		: in	std_logic;
	-- VGA ----------------
--	VGA_B		: out	std_logic_vector(7 downto 0);
--	VGA_BLANK_N	: out	std_logic;
--	VGA_CLK		: out	std_logic;
--	VGA_G		: out	std_logic_vector(7 downto 0);
--	VGA_HS		: out	std_logic;
--	VGA_R		: out	std_logic_vector(7 downto 0);
--	VGA_SYNC_N	: out	std_logic;
--	VGA_VS		: out	std_logic;	: out	std_logic;
 
 );
end DE1SOC_ERREPRO;

architecture str of DE1SOC_ERREPRO is 
	signal reset :  std_logic;
	signal PLAY:  std_logic;
	signal REC:  std_logic;
	signal READYOUT :  std_logic;
	signal READYIN :  std_logic;
	signal ENABLE :  std_logic;
	signal ENABLEIN :  std_logic;
	signal MEND :  std_logic;
	signal WR : std_logic;
	signal FORWARD : std_logic;
	signal BACKWARD : std_logic;
	signal SAMPLE :  std_logic_vector(15 downto 0);
	signal SAMPLEIN :  std_logic_vector(15 downto 0);
	
	-- AU_SETUP
	component au_setup IS 
	 port
	 (
		reset		   :  IN STD_LOGIC;
		clk_50 		:  IN STD_LOGIC;
		mic_lin		:  IN STD_LOGIC; -- si '1' MIC, si '0' LINEIN
		i2c_sdat	   :  INOUT STD_LOGIC;
		i2c_sclk	   :  OUT STD_LOGIC;
		aud_xck		:  OUT STD_LOGIC
	 );
	END component;
	
	
	-- AU_OUT
	component AU_OUT_PU_KU IS 
	 port (
		clk,reset: in std_logic;
		ENABLE: in std_logic;
		SAMPLE: in std_logic_vector (15 downto 0);
		DACDAT: out std_logic;
		BCLK: in std_logic;
		DACLRC: in std_logic;
		READYOUT: out std_logic
	 );
	end component;
	
	
	-- MAIN
	component MAIN_PU_KU is 
	 port (
		clk,reset: in std_logic;
		ENABLE: out std_logic;
		ENABLEIN: out std_logic;
		SAMPLE: out std_logic_vector (15 downto 0);
		SAMPLEIN: in std_logic_vector (15 downto 0);
		PLAY, REC, READYOUT, READYIN, FORWARD, BACKWARD: in std_logic;
		MEND: out std_logic
	 );
   end component;
   
   -- AU_IN
   component AU_IN_PU_KU is
    port (
		clk,reset: in std_logic;
		ENABLEIN: in std_logic;
		SAMPLEIN: out std_logic_vector (15 downto 0);
		ADCDAT: in std_logic;
		BCLK: in std_logic;
		ADCLRC: in std_logic;
		READYIN: out std_logic
	);
	end component;
begin 
	reset <= not(KEY(0));
   PLAY <= SW(0);
	LEDR(0) <= MEND;
	REC <= not(KEY(1));
	FORWARD <= not(KEY(2));
	BACKWARD <= not(KEY(3));

	
	uset: au_setup 
	port map(
		reset => reset, clk_50 => CLOCK_50,  mic_lin => '1', 
		i2c_sdat => FPGA_I2C_SDAT, i2c_sclk => FPGA_I2C_SCLK, aud_xck => AUD_XCK	
	);
	
	uout: AU_OUT_PU_KU
	port map(
		clk => CLOCK_50, reset => reset, ENABLE => ENABLE, SAMPLE => SAMPLE, DACDAT => AUD_DACDAT,  
		 BCLK => AUD_BCLK, DACLRC => AUD_DACLRCK, READYOUT => READYOUT
	);
	
	uin: AU_IN_PU_KU
	port map (
		clk => CLOCK_50, reset => reset, BCLK => AUD_BCLK, ADCDAT => AUD_ADCDAT, ADCLRC => AUD_ADCLRCK,
		ENABLEIN => ENABLEIN, SAMPLEIN => SAMPLEIN, READYIN => READYIN
	);
	
	main: MAIN_PU_KU
	port map(
		clk => CLOCK_50, reset => reset, ENABLE => ENABLE, ENABLEIN => ENABLEIN, SAMPLE => SAMPLE, FORWARD => FORWARD, BACKWARD => BACKWARD,
		SAMPLEIN => SAMPLEIN, PLAY => PLAY, REC => REC, READYOUT => READYOUT, READYIN => READYIN, MEND => MEND
	);
END str;
