library IEEE;
use IEEE.std_logic_1164.all;


-- ASM ALGORITMOA.

entity MAIN_KU is 
port (
clk,reset: in std_logic;
READYOUT, READYIN, PLAYSINK, AMAITU, RECSINK, FORWARDSINK, BACKWARDSINK: in std_logic;
ENABLE, ENABLEIN, LD_K, LD_H, COUNT, INKR, DEKR, MEND, WR, AKT: out std_logic
);
end MAIN_KU;

architecture arki of MAIN_KU is 

type EGOERA is (HASIERA,eo0,eo1,ei0,ei1,ITXARON,FWBW,INKREMENTATU,DEKREMENTATU,BUKAERA);
signal UE,HE: EGOERA;

begin -- ARKITEKTURAREN DEFINIZIOA

process (AMAITU, PLAYSINK, RECSINK, READYOUT, READYIN, BACKWARDSINK, FORWARDSINK, UE) 
begin
case UE is
  
  when HASIERA => HE<= ITXARON;
  
  when ITXARON => if PLAYSINK='1' then HE<= eo0;
				 elsif RECSINK='1' then HE<= ei0;
				 elsif (BACKWARDSINK='1' and FORWARDSINK='0') then HE<=DEKREMENTATU;
				 elsif (BACKWARDSINK='0' and FORWARDSINK='1') then HE<=INKREMENTATU;
				 else HE<= ITXARON;
			  end if;

  when FWBW => HE<= ITXARON;

  when DEKREMENTATU => if BACKWARDSINK='1' then HE<= DEKREMENTATU;
		     else HE<= FWBW;
		  end if;

 when INKREMENTATU => if FORWARDSINK='1' then HE<= INKREMENTATU;
		     else HE<= FWBW;
		  end if;


  when eo0 => HE<= eo1;
  
  when eo1 => if PLAYSINK='0' then HE<= ITXARON;
                 elsif READYOUT='0' then HE<= eo1;
                 elsif AMAITU='1' then HE<= BUKAERA;
			     else HE<= eo0;
              end if;

  when ei0 => HE<= ei1;		
			
  when ei1 => if RECSINK='0' then HE<= ITXARON;
				 elsif READYIN='0' then HE<= ei1;
				 elsif AMAITU='1' then HE<= BUKAERA;
				 else HE<= ei0;
	          end if;
			  
  when BUKAERA => HE<=BUKAERA;			  

end case;
end process;

-- PROZESU SINKRONO BATEAN, UNEKO EGOERA (UE) ERREGISTRATZEN DA ERLOJU-ERTZERO
-- RESET ASINKRONOA

process (clk,reset)
begin
if reset='1' then UE<=HASIERA;
             elsif (clk'event and clk='1') then UE<=HE;
end if;
end process;

-- KONTROL SEINALE BAKOITZEKO, ESLEIPEN KONKURRENTE BAT

COUNT <= '1' when (UE=eo1 and PLAYSINK='1' and READYOUT='1' and AMAITU='0') or (UE=ei1 and RECSINK='1' and READYIN='1' and AMAITU='0') else '0'; 
LD_K <= '1' when (UE=HASIERA or UE=FWBW) else '0'; 
ENABLE <= '1' when (UE=eo1) else '0'; 
ENABLEIN <= '1' when (UE=ei1) else '0';
MEND <= '1' when (UE=BUKAERA) else '0';
WR <= '1' when (UE=ei1 and RECSINK='1' and READYIN='1' and AMAITU='0') else '0';
AKT <= '1' when (UE=FWBW) else '0';
INKR <= '1' when (UE=INKREMENTATU) else '0';
DEKR <= '1' when (UE=DEKREMENTATU) else '0';
LD_H <= '1' when (UE=ITXARON and PLAYSINK='0' and RECSINK='0' and BACKWARDSINK='0' and FORWARDSINK='1') or (UE=ITXARON and PLAYSINK='0' and RECSINK='0' and BACKWARDSINK='1') else '0';
end arki; 
