library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

--Biderkagailua simulatzeko testbench-a

entity AU_IN_TB IS

end AU_IN_TB;

architecture AU_IN_TB_ARCH of AU_IN_TB is
    signal reset : std_logic;
    signal clk : std_logic:='0';
    signal ENABLEIN : std_logic;
    signal ADCDAT: std_logic:='1';
    signal BCLK: std_logic:='0';
    signal ADCLRC: std_logic:='0';
    signal SAMPLEIN : std_logic_vector (15 downto 0);
    
    component AU_IN_PU_KU IS
      port (
          clk,reset: in std_logic;
          ENABLEIN: in std_logic;
          SAMPLEIN: out std_logic_vector (15 downto 0);
          ADCDAT: in std_logic;
          BCLK: in std_logic;
          ADCLRC: in std_logic
             );
    end component;
    
begin

U1: AU_IN_PU_KU port map (
   reset=>reset,clk=>clk,ENABLEIN=>ENABLEIN,SAMPLEIN=>SAMPLEIN, BCLK=>BCLK, ADCLRC=>ADCLRC, ADCDAT=>ADCDAT
   );

clk<= not clk after 10 ns;
BCLK<= not BCLK after 160 ns;
ADCLRC<= not ADCLRC after 61440 ns; --200 ns;--
ADCDAT<= not ADCDAT after 320 ns;

process
begin
  reset<='1';
  wait for 20 ns;
  ENABLEIN<='0';
  reset<='0';
  wait for 15 ns;
  ENABLEIN<='1';
  wait;
end process;

end AU_IN_TB_ARCH;
