library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

--Biderkagailua simulatzeko testbench-a

entity AU_OUT_TB IS

end AU_OUT_TB;

architecture AU_OUT_TB_ARCH of AU_OUT_TB is
    signal reset : std_logic;
        signal clk : std_logic:='0';
        signal ENABLE : std_logic;
    signal DACDAT: std_logic;
    signal BCLK: std_logic:='1';
    signal DACLRC: std_logic:='0';
    signal SAMPLE : std_logic_vector (15 downto 0);
    
    component AU_OUT IS
      port (
              clk,reset: in std_logic;
          ENABLE: in std_logic;
          SAMPLE: in std_logic_vector (15 downto 0);
          DACDAT: out std_logic;
          BCLK: in std_logic;
          DACLRC: in std_logic
             );
    end component;
    
begin

U1: AU_OUT port map (
   reset=>reset,clk=>clk,ENABLE=>ENABLE,SAMPLE=>SAMPLE,DACDAT=>DACDAT, BCLK=>BCLK, DACLRC=>DACLRC
   );

clk<= not clk after 10 ns;
BCLK<= not BCLK after 160 ns;
DACLRC<= not DACLRC after 61440 ns; --200 ns;--

process
begin
  SAMPLE<="1010101001010101";
  wait for 20 ns;
  ENABLE<='0';
  reset<='1';
  wait for 5 ns;
  reset<='0';
  wait for 15 ns;
  ENABLE<='1';
  wait;
end process;

end AU_OUT_TB_ARCH;
