library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

--Main simulatzeko testbench-a

entity MAIN_TB IS

end MAIN_TB;

architecture MAIN_TB_ARCH of MAIN_TB is
    signal reset : std_logic;
    signal clk : std_logic:='0'; 
    signal PLAY : std_logic:='0';
    signal REC: std_logic:='0';
    signal READYOUT: std_logic;
    signal READYIN: std_logic;
    signal ENABLE: std_logic; 
    signal ENABLEIN: std_logic;
    signal FORWARD: std_logic;
    signal BACKWARD: std_logic;
    signal SAMPLEIN: std_logic_vector (15 downto 0);
    signal SAMPLE: std_logic_vector (15 downto 0);
    
    component MAIN_PU_KU IS
      port (
          clk,reset: in std_logic;
          PLAY: in std_logic;
	  REC: in std_logic;
          READYOUT: in std_logic;
	  READYIN: in std_logic;
          SAMPLE: out std_logic_vector (15 downto 0);
	  SAMPLEIN: in std_logic_vector (15 downto 0);
	  MEND: out std_logic;
	  ENABLE: out std_logic;
	  ENABLEIN: out std_logic;
	  FORWARD: in std_logic;
	  BACKWARD: in std_logic
          );
    end component;
    
begin

U1: MAIN_PU_KU port map (
   reset=>reset,clk=>clk,ENABLE=>ENABLE, ENABLEIN=>ENABLEIN,PLAY=>PLAY,READYOUT=>READYOUT,SAMPLE=>SAMPLE, SAMPLEIN=>SAMPLEIN, READYIN=>READYIN, REC=>REC, FORWARD => FORWARD, BACKWARD => BACKWARD
   );

clk<= not clk after 10 ns;
SAMPLEIN <="0000000000000001";

process
begin
  
  reset<='0';
  wait for 10 ns;
  reset<='1';
  wait for 5 ns;
  reset<='0';
  READYIN<='0';
  PLAY<='0';
  REC<='0';
  READYOUT<='0';
  wait for 10 ns;
  READYIN<='1';
  wait for 20 ns;
  REC<='1';
  wait for 240 ns;
  REC<='0';
  READYIN<='0';
  wait for 20 ns;
  PLAY<='1';
  wait for 60 ns;
  READYOUT<='1';
  wait for 40 ns;
  PLAY<='0';
  wait for 60 ns;
  PLAY<='1';
  wait for 240 ns;
  READYOUT<='0';
  wait for 60 ns;
  PLAY<='0';
  FORWARD<='0';
  BACKWARD<='0';
  wait for 25 ns;
  BACKWARD<='1';
  wait for 60 ns;
  BACKWARD<='0';
  FORWARD<='1';
  wait for 60 ns;
  FORWARD<='0';
  wait;

end process;

end MAIN_TB_ARCH;
