library ieee;
use ieee.std_logic_1164.all; 
use ieee.numeric_std.all; 
use work.ramdata_pkg.all;

entity ramsinc is
  port (
    clk		: in  std_logic;
    we		: in  std_logic;
    addr	: in  std_logic_vector(15 downto 0);
    datin	: in  std_logic_vector(15 downto 0);
    datout	: out std_logic_vector(15 downto 0)
  );
end entity ramsinc;

architecture a of ramsinc is
--   type ram_type is array (0 to (2**16)-1) of std_logic_vector(15 downto 0);
   signal ram : ram_type := ramdata;
   signal read_addr : std_logic_vector(15 downto 0);
begin
  process(clk) is
  begin
    if (clk'event and clk='1') then
      if we='1' then
        ram(to_integer(unsigned(addr))) <= datin;
      end if;
      read_addr <= addr;
    end if;
  end process;

  datout <= ram(to_integer(unsigned(read_addr)));

end architecture a;